Subject: Re: [Idr] Recommend Book on BGP

From: Curtis Villamizar <[email-masked]>
Date: Mon, 03 Oct 2005 12:14:06 -0400

In message <[email-masked]>
Adam Greenhalgh writes:
>  
> Perhaps you might like to take a look at the XORP modular router's bgp
> code, http://www.xorp.org , some details about the implementation are
> here :
> http://www.cs.ucl.ac.uk/staff/M.Handley/papers/xorp-nsdi.pdf
>  
> Adam

Adam,

Thanks for the pointer.  That paper is certainly a good start.  I'm
more familiar with the Gated implementation.  I don't know if there
was an archive of e-mail among the gated developers while the Gated
Consortium was still at Cornell but that is when the original gated
BGP-4 implementation was written (mostly by Dennis Furgusson) and when
the most open discussion of BGP scaling considerations was going on
(at least that I know of).  Gated documentation from the old public
releases might help.

Curtis

> On 03/10/05, Curtis Villamizar <[email-masked]> wrote:
> >
> > In message <[email-masked]>
> > "john smith" writes:
> > >
> > > The RFC seems fine,
> > >
> > > perhaps something like "BGP is based on the Bellman-Ford algorithm" etc.
> > > would be a nice line to add....
> > >
> > >
> > > >From: Jing Shen <[email-masked]>
> > > >To: [email-masked]
> > > >Subject: [Idr] Recommend Book on BGP
> > > >Date: Fri, 30 Sep 2005 16:57:13 +0800 (CST)
> > > >
> > > >Hi,
> > > >
> > > >I'm sorry if this is off-topic.
> > > >
> > > >Would anybody recommend some book on BGP? Someone
> > > >recommend Halabi's book, but it seems focusing on
> > > >operational area. Is there any book discussing how BGP
> > > >is designed and implemented?
> > > >
> > > >thanks
> > > >
> > > >Joe shen
> >
> >
> > John,
> >
> > The question seemed to be more focused on how to design and code a BGP
> > implementation, presumably one that will not fail when deployed in a
> > real network.  I sent Mr. Shen a private message indicating that there
> > was no really good book on BGP implementation.  The lessons learned
> > about BGP's behaviour in real networds and the implications for data
> > structures and algorithms used to implement BGP is not to my knowledge
> > available in any textbook.
> >
> > There are plenty of anecdotal examples in IETF and NANOG archives of
> > things that weren't done right the first time in some implementations.
> > Even basic things like making writes non-blocking and properly
> > handling non-blocking writes have been missed by some implementations.
> > One prominent implementation at one time had a linked list of per
> > prefix policy statements despite the known poor search time for a
> > linked list.  An example of a misfeature is one vendors ill conceived
> > "optimization" of sending route deletes to all peers even if no route
> > announcement had been sent to a subset of those peers.  All of these
> > problems are corrected in today's major implementations.
> >
> > Though not in any textbook, apparently this stuff is far enough from
> > obvious that it wouldn't hurt to be in one.  The reason it isn't may
> > be that the audience for such a book is too small or there is a lack
> > of people with the capabilty and time to write it.
> >
> > That sort of thing doesn't belong in the RFC and mentioning
> > Bellman-Ford doesn't come anywhere close to covering the topic.
> >
> > Curtis
> >
> > ps - History also has plenty of at one time deployed "how not to
> > design a router" problems that are not specific to BGP.
> >
> > _______________________________________________
> > Idr mailing list
> > [email-masked]
> > https://www1.ietf.org/mailman/listinfo/idr

_______________________________________________
Idr mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/idr

---

From: "Dow M. Street" <[email-masked]>
Date: Mon, 3 Oct 2005 11:11:40 -0700

If still looking for a "book", you may find Network Algorithmics  
(ISBN: 0-12-088477-1) useful in general concepts, if not BGP specifics..